Subject: Re: [rtcweb] OPS-Dir review of draft-ietf-rtcweb-stun-consent-freshness-13

From: Muthu Arul Mozhi Perumal <[email-masked]>
Date: Mon, 1 Jun 2015 18:40:48 +0530

I think RFC5245 does not rule out someone using STUN binding requests for
keepalive:

<snip>
   Though Binding Indications are used for keepalives,
   an agent MUST be prepared to receive a connectivity check as well.
   If a connectivity check is received, a response is generated as
   discussed in [RFC5389], but there is no impact on ICE processing
   otherwise.
</snip>

OLD:
    If consent is performed then there is no need to send keepalive
messages.

Suggested NEW:
   If consent is performed then the STUN binding requests sent for consent
   freshness also serve the keepalive purpose.

That is effectively what RFC5245 says for keepalive..

Muthu

On Fri, May 29, 2015 at 11:41 PM, Black, David <[email-masked]> wrote:

>  That also works for me, and neatly sidesteps the concern about
>
> whether RFC 5245 is being updated.
>
>
>
> Thanks,
> --David
>
>
>
> *From:* Tirumaleswar Reddy (tireddy) [mailto:[email-masked]]
> *Sent:* Thursday, May 28, 2015 11:20 PM
> *To:* Christer Holmberg; Ted Hardie; Black, David
>
> *Cc:* joel jaeggli; [email-masked]; [email-masked];
> [email-masked]
> *Subject:* RE: [rtcweb] OPS-Dir review of
> draft-ietf-rtcweb-stun-consent-freshness-13
>
>
>
> *From:* Christer Holmberg [mailto:[email-masked]
> <[email-masked]>]
> *Sent:* Friday, May 29, 2015 7:37 AM
> *To:* Tirumaleswar Reddy (tireddy); Ted Hardie; Black, David
> *Cc:* joel jaeggli; [email-masked]; [email-masked];
> [email-masked]
> *Subject:* RE: [rtcweb] OPS-Dir review of
> draft-ietf-rtcweb-stun-consent-freshness-13
>
>
>
> Hi,
>
>
>
> >Good point. We discuss the following point in section 4.1 of the draft
> about keepalives:
>
> >
>
> >   An endpoint that is not sending any application data does not need to
>
> >   maintain consent.  However, not sending any traffic could cause NAT
>
> >   or firewall mappings to expire.  Furthermore, having one peer unable
>
> >   to send is detrimental to many protocols.  Absent better information
>
> >   about the network, if an endpoint needs to ensure its NAT or firewall
>
> >   mappings do not expire, it can be done using keepalive or other
>
> >   techniques (see Section 10 of [RFC5245]
> <http://tools.ietf.org/html/rfc5245#section-10> and see [RFC6263
> <http://tools.ietf.org/html/rfc6263>]).
>
> >
>
> > So there is no need to send keepalives because of the media traffic as
> it is pointed out in Section 20.2.3 of RFC 5245
>
> > irrespective of whether consent is used or not. I think we can remove
> the following line in “If consent is performed then
>
> > there is no need to send keepalive messages." and avoid the confusion
> of updating RFC 5245.
>
>
>
> I agree that the current text can confuse people, but I still think it
> would be good to have explicit text saying that keepalives are not sent.
> Perhaps something like:
>
>
>
> “From a keepalive perspective, consent requests are considered media
> traffic. Because of that, dedicated keepalives (e.g. STUN binding requests)
> are not sent on candidate pairs where consent requests are sent, in
> accordance with Section 20.2.3 of [RFC5245].”
>
>
>
> Works for me (Replaced STUN binding requests with STUN Binding
> Indications in the above line).
>
>
>
> Cheers,
>
> -Tiru
>
>
>
> Regards,
>
>
>
> Christer
>
>
>
>
>
> *From:* rtcweb [mailto:[email-masked] <[email-masked]>] *On
> Behalf Of *Christer Holmberg
> *Sent:* Friday, May 29, 2015 6:54 AM
> *To:* Ted Hardie; Black, David
> *Cc:* joel jaeggli; [email-masked]; [email-masked];
> [email-masked]
> *Subject:* Re: [rtcweb] OPS-Dir review of
> draft-ietf-rtcweb-stun-consent-freshness-13
>
>
>
>
>
> Hi,
>
>
>
> Section 20.2.3 of RFC 5245 says:
>
>
>
> “STUN keepalives (in the form of STUN Binding Indications) are sent in
>
>               the middle of a media session.  However, *they are sent
> only in the*
>
> *              absence of actual media traffic*.”
>
>
>
> So, in the consent draft we could say that, from a keepalive perspective,
> consent requests are considered media traffic. That would then implicitly
> mean that actual keepalives aren’t sent when consent is used. That way, the
> consent spec would be compliant to 5245, and there would be no need for any
> update etc…
>
>
>
> Regards,
>
>
>
> Christer
>
>
>
>
>
> *From:* rtcweb [mailto:[email-masked] <[email-masked]>] *On
> Behalf Of *Ted Hardie
> *Sent:* 28 May 2015 23:26
> *To:* Black, David
> *Cc:* [email-masked]; joel jaeggli; [email-masked];
> [email-masked]
> *Subject:* Re: [rtcweb] OPS-Dir review of
> draft-ietf-rtcweb-stun-consent-freshness-13
>
>
>
> Hi David,
>
>
>
> On Thu, May 28, 2015 at 12:36 PM, Black, David <[email-masked]>
>
>
> I'd expect that even overriding RFC 5245 counts as an Update,
> because the result would be that the original RFC 5245 "MUST" requirement
> is no longer globally applicable to all uses of RFC 5245.  In other words,
> overriding RFC 5245 effectively rewrites the "MUST" to become "MUST, except
> as further specified by the consent RFC."
>
>
>
> ​So I agree with you that this must be called out, but I think "Updates"
> is wrong for the draft's current intent.  I think what Martin has said
> amounts to "We have chosen to follow RFC 5245 except as detailed in
> sections X and Y, where we use a different set of messages to optimize the
> combination of heartbeat and consent."  We are not updating RFC 5245
> thereby, because we are neither changing its core semantics nor offering to
> add a new, general semantic to RFC 5245 (we could have made that choice,
> but are not doing so now).  Instead of updating RFC 5245, in other words,
> we are limiting our reference to it.
>
> That should be done explicitly, and I think it should be called it
> suffiiciently that a new spin of the draft likely needs a new round of
> review.  But I don't think we are required to update RFC 5245 to get that
> done.
>
> I've referred the matter to our friendly AD, and we await her reading on
> next steps on this.  In either approach, however, this will get called out.
>
> regards,
>
> Ted HArdie​
>
>
>
> _______________________________________________
> rtcweb mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/rtcweb
>
>

---

From: "Tirumaleswar Reddy (tireddy)" <[email-masked]>
Date: Tue, 2 Jun 2015 03:14:07 +0000

From: Muthu Arul Mozhi Perumal [mailto:[email-masked]]
Sent: Monday, June 01, 2015 6:41 PM
To: Black, David
Cc: Tirumaleswar Reddy (tireddy); Christer Holmberg; Ted Hardie; joel jaeggli; [email-masked]; [email-masked]; [email-masked]
Subject: Re: [rtcweb] OPS-Dir review of draft-ietf-rtcweb-stun-consent-freshness-13

I think RFC5245 does not rule out someone using STUN binding requests for keepalive:

<snip>

OLD:
    If consent is performed then there is no need to send keepalive messages.

Suggested NEW:

Updated in my local copy.

-Tiru

Muthu

On Fri, May 29, 2015 at 11:41 PM, Black, David <[email-masked]<mailto:[email-masked]>> wrote:
That also works for me, and neatly sidesteps the concern about
whether RFC 5245 is being updated.

Thanks,
--David

From: Tirumaleswar Reddy (tireddy) [mailto:[email-masked]<mailto:[email-masked]>]
Sent: Thursday, May 28, 2015 11:20 PM
To: Christer Holmberg; Ted Hardie; Black, David

Cc: joel jaeggli; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: RE: [rtcweb] OPS-Dir review of draft-ietf-rtcweb-stun-consent-freshness-13

From: Christer Holmberg [mailto:[email-masked]]
Sent: Friday, May 29, 2015 7:37 AM
To: Tirumaleswar Reddy (tireddy); Ted Hardie; Black, David
Cc: joel jaeggli; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: RE: [rtcweb] OPS-Dir review of draft-ietf-rtcweb-stun-consent-freshness-13

Hi,

>Good point. We discuss the following point in section 4.1 of the draft about keepalives:
>
>   techniques (see Section 10 of [RFC5245]<http://tools.ietf.org/html/rfc5245#section-10> and see [RFC6263<http://tools.ietf.org/html/rfc6263>]).
>
> So there is no need to send keepalives because of the media traffic as it is pointed out in Section 20.2.3 of RFC 5245
> irrespective of whether consent is used or not. I think we can remove the following line in “If consent is performed then
> there is no need to send keepalive messages." and avoid the confusion of updating RFC 5245.

I agree that the current text can confuse people, but I still think it would be good to have explicit text saying that keepalives are not sent. Perhaps something like:

“From a keepalive perspective, consent requests are considered media traffic. Because of that, dedicated keepalives (e.g. STUN binding requests) are not sent on candidate pairs where consent requests are sent, in accordance with Section 20.2.3 of [RFC5245].”

Works for me (Replaced STUN binding requests with STUN Binding Indications in the above line).

Cheers,
-Tiru

Regards,

Christer

From: rtcweb [mailto:[email-masked]] On Behalf Of Christer Holmberg
Sent: Friday, May 29, 2015 6:54 AM
To: Ted Hardie; Black, David
Cc: joel jaeggli; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: Re: [rtcweb] OPS-Dir review of draft-ietf-rtcweb-stun-consent-freshness-13

Hi,

“STUN keepalives (in the form of STUN Binding Indications) are sent in
              the middle of a media session.  However, they are sent only in the
              absence of actual media traffic.”

So, in the consent draft we could say that, from a keepalive perspective, consent requests are considered media traffic. That would then implicitly mean that actual keepalives aren’t sent when consent is used. That way, the consent spec would be compliant to 5245, and there would be no need for any update etc…

Regards,

Christer

From: rtcweb [mailto:[email-masked]] On Behalf Of Ted Hardie
Sent: 28 May 2015 23:26
To: Black, David
Cc: [email-masked]<mailto:[email-masked]>; joel jaeggli; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: Re: [rtcweb] OPS-Dir review of draft-ietf-rtcweb-stun-consent-freshness-13

Hi David,

On Thu, May 28, 2015 at 12:36 PM, Black, David <[email-masked]<mailto:[email-masked]>>

​So I agree with you that this must be called out, but I think "Updates" is wrong for the draft's current intent.  I think what Martin has said amounts to "We have chosen to follow RFC 5245 except as detailed in sections X and Y, where we use a different set of messages to optimize the combination of heartbeat and consent."  We are not updating RFC 5245 thereby, because we are neither changing its core semantics nor offering to add a new, general semantic to RFC 5245 (we could have made that choice, but are not doing so now).  Instead of updating RFC 5245, in other words, we are limiting our reference to it.
That should be done explicitly, and I think it should be called it suffiiciently that a new spin of the draft likely needs a new round of review.  But I don't think we are required to update RFC 5245 to get that done.
I've referred the matter to our friendly AD, and we await her reading on next steps on this.  In either approach, however, this will get called out.
regards,
Ted HArdie​

_______________________________________________
rtcweb mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/rtcweb

---

From: "Black, David" <[email-masked]>
Date: Tue, 2 Jun 2015 14:14:28 +0000

There’s been a lot of discussion - would it be reasonable for the authors to submit a new (-14) version, so we can see what the results look like at this point?

Thanks,
--David

From: Tirumaleswar Reddy (tireddy) [mailto:[email-masked]]
Sent: Monday, June 01, 2015 11:14 PM
To: Muthu Arul Mozhi Perumal; Black, David
Cc: Christer Holmberg; Ted Hardie; joel jaeggli; [email-masked]; [email-masked]; [email-masked]
Subject: RE: [rtcweb] OPS-Dir review of draft-ietf-rtcweb-stun-consent-freshness-13

From: Muthu Arul Mozhi Perumal [mailto:[email-masked]]
Sent: Monday, June 01, 2015 6:41 PM
To: Black, David
Cc: Tirumaleswar Reddy (tireddy); Christer Holmberg; Ted Hardie; joel jaeggli; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>; [email-masked]<mailto:[email-masked]>
Subject: Re: [rtcweb] OPS-Dir review of draft-ietf-rtcweb-stun-consent-freshness-13

<snip>

OLD:

Suggested NEW:

-Tiru

Muthu

Thanks,
--David

Hi,

Cheers,
-Tiru

Regards,

Christer

Hi,

Regards,

Christer

Hi David,